Step 2: Submit username (initiate MFA)
POST {{authPath}}/{{envID}}/flows/{{flowID}}
To respond to the SIGN_ON_REQUIRED flow state, the user initiates the user.lookup action. The flow service calls the POST /{{envID}}/flows/{{flowID}} endpoint operation and uses the application/vnd.pingidentity.user.lookup+json custom media type in the Content-type HTTP request header to identify the action.
The request body requires the username property, which identifies a valid user. In this workflow, if the user.lokup action completes successfully, the flow proceeds to the next sign-on policy action. The flow status value of OTP_REQUIRED requires a one-time password verification.
The response includes a link for the otp.check action as an option for this flow. This option is available because the sign-on policy includes the MULTIFACTOR_AUTHENTICATION policy action to prompt the user to complete an MFA action.
Example Request
-
cURL
-
C#
-
Go
-
HTTP
-
Java
-
jQuery
-
NodeJS
-
Python
-
PHP
-
Ruby
-
Swift
curl --location --globoff '{{authPath}}/{{envID}}/flows/{{flowID}}' \
--header 'Content-Type: application/vnd.pingidentity.user.lookup+json' \
--data '{
"username": "{{sharedUsername}}"
}'
var options = new RestClientOptions("{{authPath}}/{{envID}}/flows/{{flowID}}")
{
MaxTimeout = -1,
};
var client = new RestClient(options);
var request = new RestRequest("", Method.Post);
request.AddHeader("Content-Type", "application/vnd.pingidentity.user.lookup+json");
var body = @"{" + "\n" +
@" ""username"": ""{{sharedUsername}}""" + "\n" +
@"}";
request.AddStringBody(body, DataFormat.Json);
RestResponse response = await client.ExecuteAsync(request);
Console.WriteLine(response.Content);
package main
import (
"fmt"
"strings"
"net/http"
"io"
)
func main() {
url := "{{authPath}}/{{envID}}/flows/{{flowID}}"
method := "POST"
payload := strings.NewReader(`{
"username": "{{sharedUsername}}"
}`)
client := &http.Client {
}
req, err := http.NewRequest(method, url, payload)
if err != nil {
fmt.Println(err)
return
}
req.Header.Add("Content-Type", "application/vnd.pingidentity.user.lookup+json")
res, err := client.Do(req)
if err != nil {
fmt.Println(err)
return
}
defer res.Body.Close()
body, err := io.ReadAll(res.Body)
if err != nil {
fmt.Println(err)
return
}
fmt.Println(string(body))
}
POST /{{envID}}/flows/{{flowID}} HTTP/1.1
Host: {{authPath}}
Content-Type: application/vnd.pingidentity.user.lookup+json
{
"username": "{{sharedUsername}}"
}
OkHttpClient client = new OkHttpClient().newBuilder()
.build();
MediaType mediaType = MediaType.parse("application/vnd.pingidentity.user.lookup+json");
RequestBody body = RequestBody.create(mediaType, "{\n \"username\": \"{{sharedUsername}}\"\n}");
Request request = new Request.Builder()
.url("{{authPath}}/{{envID}}/flows/{{flowID}}")
.method("POST", body)
.addHeader("Content-Type", "application/vnd.pingidentity.user.lookup+json")
.build();
Response response = client.newCall(request).execute();
var settings = {
"url": "{{authPath}}/{{envID}}/flows/{{flowID}}",
"method": "POST",
"timeout": 0,
"headers": {
"Content-Type": "application/vnd.pingidentity.user.lookup+json"
},
"data": JSON.stringify({
"username": "{{sharedUsername}}"
}),
};
$.ajax(settings).done(function (response) {
console.log(response);
});
var request = require('request');
var options = {
'method': 'POST',
'url': '{{authPath}}/{{envID}}/flows/{{flowID}}',
'headers': {
'Content-Type': 'application/vnd.pingidentity.user.lookup+json'
},
body: JSON.stringify({
"username": "{{sharedUsername}}"
})
};
request(options, function (error, response) {
if (error) throw new Error(error);
console.log(response.body);
});
import requests
import json
url = "{{authPath}}/{{envID}}/flows/{{flowID}}"
payload = json.dumps({
"username": "{{sharedUsername}}"
})
headers = {
'Content-Type': 'application/vnd.pingidentity.user.lookup+json'
}
response = requests.request("POST", url, headers=headers, data=payload)
print(response.text)
<?php
require_once 'HTTP/Request2.php';
$request = new HTTP_Request2();
$request->setUrl('{{authPath}}/{{envID}}/flows/{{flowID}}');
$request->setMethod(HTTP_Request2::METHOD_POST);
$request->setConfig(array(
'follow_redirects' => TRUE
));
$request->setHeader(array(
'Content-Type' => 'application/vnd.pingidentity.user.lookup+json'
));
$request->setBody('{\n "username": "{{sharedUsername}}"\n}');
try {
$response = $request->send();
if ($response->getStatus() == 200) {
echo $response->getBody();
}
else {
echo 'Unexpected HTTP status: ' . $response->getStatus() . ' ' .
$response->getReasonPhrase();
}
}
catch(HTTP_Request2_Exception $e) {
echo 'Error: ' . $e->getMessage();
}
require "uri"
require "json"
require "net/http"
url = URI("{{authPath}}/{{envID}}/flows/{{flowID}}")
http = Net::HTTP.new(url.host, url.port);
request = Net::HTTP::Post.new(url)
request["Content-Type"] = "application/vnd.pingidentity.user.lookup+json"
request.body = JSON.dump({
"username": "{{sharedUsername}}"
})
response = http.request(request)
puts response.read_body
let parameters = "{\n \"username\": \"{{sharedUsername}}\"\n}"
let postData = parameters.data(using: .utf8)
var request = URLRequest(url: URL(string: "{{authPath}}/{{envID}}/flows/{{flowID}}")!,timeoutInterval: Double.infinity)
request.addValue("application/vnd.pingidentity.user.lookup+json", forHTTPHeaderField: "Content-Type")
request.httpMethod = "POST"
request.httpBody = postData
let task = URLSession.shared.dataTask(with: request) { data, response, error in
guard let data = data else {
print(String(describing: error))
return
}
print(String(data: data, encoding: .utf8)!)
}
task.resume()
Example Response
200 OK
{
"_links": {
"otp.check": {
"href": "https://auth.pingone.com/abfba8f6-49eb-49f5-a5d9-80ad5c98f9f6/flows/0305793d-7b59-4b59-a1a4-043287dd5d64"
},
"device.select": {
"href": "https://auth.pingone.com/abfba8f6-49eb-49f5-a5d9-80ad5c98f9f6/flows/0305793d-7b59-4b59-a1a4-043287dd5d64"
},
"self": {
"href": "https://auth.pingone.com/abfba8f6-49eb-49f5-a5d9-80ad5c98f9f6/flows/0305793d-7b59-4b59-a1a4-043287dd5d64"
}
},
"id": "0305793d-7b59-4b59-a1a4-043287dd5d64",
"resumeUrl": "https://auth.pingone.com/abfba8f6-49eb-49f5-a5d9-80ad5c98f9f6/as/resume?flowId=0305793d-7b59-4b59-a1a4-043287dd5d64",
"status": "OTP_REQUIRED",
"createdAt": "2026-04-22T19:05:49.950Z",
"expiresAt": "2026-04-22T19:21:03.741Z",
"_embedded": {
"devices": [
{
"id": "eb8ef69e-6d08-41b3-97d9-167c801fa6f5",
"type": "EMAIL",
"status": "ACTIVE",
"usableStatus": {
"status": "ENABLED"
},
"email": "jo****@pingidentity.com"
}
],
"user": {
"id": "386e547a-45b6-410f-b61f-e4f4dc177fac"
},
"application": {
"name": "WebAppPasswordless_1776884559"
}
},
"otpLength": 6,
"bypassAllowed": false,
"selectedDevice": {
"id": "eb8ef69e-6d08-41b3-97d9-167c801fa6f5"
}
}